# PyQNormaliz - An interface to QNormaliz


## What is PyQNormaliz

PyQNormaliz provides an interface to QNormaliz (https://www.normaliz.uni-osnabrueck.de) via libQNormaliz. It offers the complete functionality of QNormaliz, and can be used interactively from python.

## Requirements

* python 2.7 or higher or python 3.4 or higher
* Normaliz 3.6.0 or higher  (https://github.com/Normaliz/Normaliz/releases)

## Installation

The PyQNormaliz install script assumes that you have executed the
```
install_normaliz_with_qnormaliz_eantic.sh
```
script. To install PyNormaliz and PyQNormaliz navigate to the Normaliz directory and type
```
./install_pynormaliz.sh --user
```

The script can be customized by some options. See Appendix E of the [Normaliz manual](https://github.com/Normaliz/Normaliz/blob/master/doc/Normaliz.pdf).

## Usage

See this [notebook](https://nbviewer.jupyter.org/github/sebasguts/PyQNormaliz/blob/master/examples/Dodecahedron.ipynb) as an example.